minimum-generator-version: '0.31.25'

inherit:
- base
- python-env

variables:
  pip.binary:2: pip 
  pip.binary:3: pip3
  pip.binary: ${pip.binary:${python.version}}

  extra-requires:
  - setuptools: pip

aspects:
- name: pip.shell
  aspect: shell
  variables:
    environment.exports: |
      export ${python.environment|[]}

    pip.package-lines: '${pip.packages|[]} '
    pip.option-lines: '${pip.options|[]} '
    pip.requirements.option-lines: '${pip.requirements-options|[]} '

    aspect.builder-constraints.shell:
    - [ after, { name: dependency-download } ]
    aspect.shell.command: |
        @{environment.exports}

        trimmed=`echo @{pip.package-lines}`

        if [ -n "$trimmed" ]; then 
          ${pip.binary} install @{pip.option-lines} @{pip.package-lines}
        else
          if [ -f "requirements.txt" ]; then
            ${pip.binary} install @{pip.requirements.option-lines} -r requirements.txt
          fi

          if [ -f "setup.py" ]; then
            ${pip.binary} install @{pip.option-lines} .
          elif [ -f "pyproject.toml" ]; then
            ${pip.binary} install @{pip.option-lines} .
          fi
        fi
      
       

        
        
